> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nectarclimate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Basic Utility Account Connection

> Create a basic utility account connection for a company. Supports username/password authentication and optionally security questions. Connections requiring MFA must use magic links. Requires company access and a list of sites in the request body.



## OpenAPI

````yaml /api-reference/openapi-v2-2.json post /connection/company/{company_id}
openapi: 3.1.0
info:
  title: Nectar API Documentation
  version: 1.0.0 (v1)
  description: >-
    Complete API documentation for v2.2 endpoints to managing companies, sites,
    data, and documents
servers:
  - url: https://external.nectarclimate.com/v2.2
    description: Nectar API Server
security: []
paths:
  /connection/company/{company_id}:
    post:
      tags:
        - Connections
      summary: Create Basic Utility Account Connection
      description: >-
        Create a basic utility account connection for a company. Supports
        username/password authentication and optionally security questions.
        Connections requiring MFA must use magic links. Requires company access
        and a list of sites in the request body.
      operationId: connection_company_create
      parameters:
        - in: path
          name: company_id
          schema:
            type: string
            format: uuid
          description: ID of the company to retrieve utility account connections for.
          required: true
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ConnectionBasicCreateRequest'
          application/x-www-form-urlencoded:
            schema:
              $ref: '#/components/schemas/ConnectionBasicCreateRequest'
          multipart/form-data:
            schema:
              $ref: '#/components/schemas/ConnectionBasicCreateRequest'
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/Connection'
          description: ''
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: ''
        '403':
          description: 'Forbidden: Access to the company is denied.'
        '404':
          description: Company not found.
      security:
        - ExternalAuthentication: []
components:
  schemas:
    ConnectionBasicCreateRequest:
      type: object
      description: >-
        Request body for creating a basic utility account connection using
        username and password.
      properties:
        url:
          type: string
          minLength: 1
          description: >-
            Web address of the utility company's website. This page may be
            either the homepage or the login page for the utility company. This
            is where the integration will attempt to authenticate.
          maxLength: 5000
        username:
          type: string
          writeOnly: true
          minLength: 1
          description: >-
            Username for the utility account connection. This is used to
            authenticate with the utility provider.
          maxLength: 200
        password:
          type: string
          writeOnly: true
          minLength: 1
          description: >-
            Password for the utility account connection. This is used to
            authenticate with the utility provider. It will be encrypted before
            storage and never exposed publicly.
          maxLength: 200
        sites:
          type: array
          items:
            type: string
            format: uuid
          description: >-
            List of site UUIDs associated with the utility account connection.
            At least one site is required.
        country:
          allOf:
            - $ref: '#/components/schemas/CountryEnum'
          description: |-
            Country of the utility company.

            * `AF` - Af
            * `AL` - Al
            * `DZ` - Dz
            * `AS` - As
            * `AD` - Ad
            * `AO` - Ao
            * `AI` - Ai
            * `AQ` - Aq
            * `AG` - Ag
            * `AR` - Ar
            * `AM` - Am
            * `AW` - Aw
            * `AU` - Au
            * `AT` - At
            * `AZ` - Az
            * `BS` - Bs
            * `BH` - Bh
            * `BD` - Bd
            * `BB` - Bb
            * `BY` - By
            * `BE` - Be
            * `BZ` - Bz
            * `BJ` - Bj
            * `BM` - Bm
            * `BT` - Bt
            * `BO` - Bo
            * `BQ` - Bq
            * `BA` - Ba
            * `BW` - Bw
            * `BV` - Bv
            * `BR` - Br
            * `IO` - Io
            * `BN` - Bn
            * `BG` - Bg
            * `BF` - Bf
            * `BI` - Bi
            * `KH` - Kh
            * `CM` - Cm
            * `CA` - Ca
            * `CV` - Cv
            * `KY` - Ky
            * `CF` - Cf
            * `TD` - Td
            * `CL` - Cl
            * `CN` - Cn
            * `CX` - Cx
            * `CC` - Cc
            * `CO` - Co
            * `KM` - Km
            * `CG` - Cg
            * `CD` - Cd
            * `CK` - Ck
            * `CR` - Cr
            * `HR` - Hr
            * `CU` - Cu
            * `CW` - Cw
            * `CY` - Cy
            * `CZ` - Cz
            * `CI` - Ci
            * `DK` - Dk
            * `DJ` - Dj
            * `DM` - Dm
            * `DO` - Do
            * `EC` - Ec
            * `EG` - Eg
            * `SV` - Sv
            * `GQ` - Gq
            * `ER` - Er
            * `EE` - Ee
            * `ET` - Et
            * `FK` - Fk
            * `FO` - Fo
            * `FJ` - Fj
            * `FI` - Fi
            * `FR` - Fr
            * `GF` - Gf
            * `PF` - Pf
            * `TF` - Tf
            * `GA` - Ga
            * `GM` - Gm
            * `GE` - Ge
            * `DE` - De
            * `GH` - Gh
            * `GI` - Gi
            * `GR` - Gr
            * `GL` - Gl
            * `GD` - Gd
            * `GP` - Gp
            * `GU` - Gu
            * `GT` - Gt
            * `GG` - Gg
            * `GN` - Gn
            * `GW` - Gw
            * `GY` - Gy
            * `HT` - Ht
            * `HM` - Hm
            * `VA` - Va
            * `HN` - Hn
            * `HK` - Hk
            * `HU` - Hu
            * `IS` - Is
            * `IN` - In
            * `ID` - Id
            * `IR` - Ir
            * `IQ` - Iq
            * `IE` - Ie
            * `IM` - Im
            * `IL` - Il
            * `IT` - It
            * `JM` - Jm
            * `JP` - Jp
            * `JE` - Je
            * `JO` - Jo
            * `KZ` - Kz
            * `KE` - Ke
            * `KI` - Ki
            * `KP` - Kp
            * `KR` - Kr
            * `KW` - Kw
            * `KG` - Kg
            * `LA` - La
            * `LV` - Lv
            * `LB` - Lb
            * `LS` - Ls
            * `LR` - Lr
            * `LY` - Ly
            * `LI` - Li
            * `LT` - Lt
            * `LU` - Lu
            * `MO` - Mo
            * `MK` - Mk
            * `MG` - Mg
            * `MW` - Mw
            * `MY` - My
            * `MV` - Mv
            * `ML` - Ml
            * `MT` - Mt
            * `MH` - Mh
            * `MQ` - Mq
            * `MR` - Mr
            * `MU` - Mu
            * `YT` - Yt
            * `MX` - Mx
            * `FM` - Fm
            * `MD` - Md
            * `MC` - Mc
            * `MN` - Mn
            * `ME` - Me
            * `MS` - Ms
            * `MA` - Ma
            * `MZ` - Mz
            * `MM` - Mm
            * `NA` - Na
            * `NR` - Nr
            * `NP` - Np
            * `NL` - Nl
            * `NC` - Nc
            * `NZ` - Nz
            * `NI` - Ni
            * `NE` - Ne
            * `NG` - Ng
            * `NU` - Nu
            * `NF` - Nf
            * `MP` - Mp
            * `NO` - No
            * `OM` - Om
            * `PK` - Pk
            * `PW` - Pw
            * `PS` - Ps
            * `PA` - Pa
            * `PG` - Pg
            * `PY` - Py
            * `PE` - Pe
            * `PH` - Ph
            * `PN` - Pn
            * `PL` - Pl
            * `PT` - Pt
            * `PR` - Pr
            * `QA` - Qa
            * `RO` - Ro
            * `RU` - Ru
            * `RW` - Rw
            * `RE` - Re
            * `BL` - Bl
            * `SH` - Sh
            * `KN` - Kn
            * `LC` - Lc
            * `MF` - Mf
            * `PM` - Pm
            * `VC` - Vc
            * `WS` - Ws
            * `SM` - Sm
            * `ST` - St
            * `SA` - Sa
            * `SN` - Sn
            * `RS` - Rs
            * `SC` - Sc
            * `SL` - Sl
            * `SG` - Sg
            * `SX` - Sx
            * `SK` - Sk
            * `SI` - Si
            * `SB` - Sb
            * `SO` - So
            * `ZA` - Za
            * `GS` - Gs
            * `SS` - Ss
            * `ES` - Es
            * `LK` - Lk
            * `SD` - Sd
            * `SR` - Sr
            * `SJ` - Sj
            * `SZ` - Sz
            * `SE` - Se
            * `CH` - Ch
            * `SY` - Sy
            * `TW` - Tw
            * `TJ` - Tj
            * `TZ` - Tz
            * `TH` - Th
            * `TL` - Tl
            * `TG` - Tg
            * `TK` - Tk
            * `TO` - To
            * `TT` - Tt
            * `TN` - Tn
            * `TR` - Tr
            * `TM` - Tm
            * `TC` - Tc
            * `TV` - Tv
            * `UG` - Ug
            * `UA` - Ua
            * `AE` - Ae
            * `GB` - Gb
            * `US` - Us
            * `UM` - Um
            * `UY` - Uy
            * `UZ` - Uz
            * `VU` - Vu
            * `VE` - Ve
            * `VN` - Vn
            * `VG` - Vg
            * `VI` - Vi
            * `WF` - Wf
            * `EH` - Eh
            * `YE` - Ye
            * `ZM` - Zm
            * `ZW` - Zw
            * `AX` - Ax
        workflowOwnerEmail:
          type:
            - string
            - 'null'
          format: email
          description: >-
            Utility login / data owner email address. This person will receive
            notifications if data is missing or if the utility data connection
            is misconfigured.
        dataCollectionStartDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            Date when data collection for the workflow begins. This is the date
            from which Nectar will pull historical data. This field overrides
            the site and company level dataCollectionStartDate fields.
        securityQuestions:
          type:
            - array
            - 'null'
          items:
            type: object
            additionalProperties: {}
          writeOnly: true
          description: >-
            Optional list of security questions and answers for the utility
            account connection. Format: [{"key": "<question>", "value":
            "<answer>"}]. This is used to authenticate with utility providers
            that require security questions.
        externalId:
          type:
            - string
            - 'null'
          description: >-
            External identifier for the connection. Used to associate this
            connection in Nectar with a connection within your database.
      required:
        - country
        - password
        - sites
        - url
        - username
    Connection:
      type: object
      description: >-
        Utility account connection, including its current status and magic link
        secret for editing credentials.
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the utility account connection.
        created:
          type: string
          format: date-time
          description: Timestamp when the utility account connection was created.
        updated:
          type: string
          format: date-time
          description: Timestamp when the utility account connection was last updated.
        externalId:
          type:
            - string
            - 'null'
          description: >-
            External identifier for the connection. Used to associate this
            connection in Nectar with a connection within your database.
        datasource:
          allOf:
            - $ref: '#/components/schemas/DatasourceSkeletonSerializerV2'
          description: Datasource / utility provider associated with the connection.
        accounts:
          type: array
          items:
            $ref: '#/components/schemas/AccountWithDatasourceTypes'
          default: []
          description: >-
            List of accounts associated with this connection, including which
            sites each account is linked to.
        company:
          allOf:
            - $ref: '#/components/schemas/CompanySkeletonSerializerV2'
          description: Company associated with the connection.
        url:
          type:
            - string
            - 'null'
          description: URL of the utility company's login website.
        status:
          allOf:
            - $ref: '#/components/schemas/ConnectionStatusEnum'
          description: >-
            Observable connection status, read-only to API clients. DEACTIVATED
            means the connection has been deactivated via isActive=False.
            COMPANY_INACTIVE means the parent company was deactivated. All other
            values reflect the most recent scrape outcome. See the connection
            lifecycle docs for the full enum and what each value means.


            * `PENDING` - Pending

            * `UNDER_INVESTIGATION` - Under Investigation

            * `CONNECTED` - Connected

            * `MFA_TOKEN_EXPIRED` - Mfa Token Expired

            * `PASSWORD_INCORRECT` - Password Incorrect

            * `NEW_PASSWORD_NEEDED` - New Password Needed

            * `ADDITIONAL_CREDENTIALS_NEEDED` - Additional Credentials Needed

            * `WEBSITE_DOWN` - Website Down

            * `NO_ACCOUNTS_FOUND` - No Accounts Found

            * `OTHER_ERROR` - Other Error

            * `COMPANY_INACTIVE` - Company Inactive

            * `DEACTIVATED` - Deactivated

            * `URL_INACCESSIBLE` - Url Inaccessible
        country:
          description: |-
            Country of the utility company.

            * `AF` - Af
            * `AL` - Al
            * `DZ` - Dz
            * `AS` - As
            * `AD` - Ad
            * `AO` - Ao
            * `AI` - Ai
            * `AQ` - Aq
            * `AG` - Ag
            * `AR` - Ar
            * `AM` - Am
            * `AW` - Aw
            * `AU` - Au
            * `AT` - At
            * `AZ` - Az
            * `BS` - Bs
            * `BH` - Bh
            * `BD` - Bd
            * `BB` - Bb
            * `BY` - By
            * `BE` - Be
            * `BZ` - Bz
            * `BJ` - Bj
            * `BM` - Bm
            * `BT` - Bt
            * `BO` - Bo
            * `BQ` - Bq
            * `BA` - Ba
            * `BW` - Bw
            * `BV` - Bv
            * `BR` - Br
            * `IO` - Io
            * `BN` - Bn
            * `BG` - Bg
            * `BF` - Bf
            * `BI` - Bi
            * `KH` - Kh
            * `CM` - Cm
            * `CA` - Ca
            * `CV` - Cv
            * `KY` - Ky
            * `CF` - Cf
            * `TD` - Td
            * `CL` - Cl
            * `CN` - Cn
            * `CX` - Cx
            * `CC` - Cc
            * `CO` - Co
            * `KM` - Km
            * `CG` - Cg
            * `CD` - Cd
            * `CK` - Ck
            * `CR` - Cr
            * `HR` - Hr
            * `CU` - Cu
            * `CW` - Cw
            * `CY` - Cy
            * `CZ` - Cz
            * `CI` - Ci
            * `DK` - Dk
            * `DJ` - Dj
            * `DM` - Dm
            * `DO` - Do
            * `EC` - Ec
            * `EG` - Eg
            * `SV` - Sv
            * `GQ` - Gq
            * `ER` - Er
            * `EE` - Ee
            * `ET` - Et
            * `FK` - Fk
            * `FO` - Fo
            * `FJ` - Fj
            * `FI` - Fi
            * `FR` - Fr
            * `GF` - Gf
            * `PF` - Pf
            * `TF` - Tf
            * `GA` - Ga
            * `GM` - Gm
            * `GE` - Ge
            * `DE` - De
            * `GH` - Gh
            * `GI` - Gi
            * `GR` - Gr
            * `GL` - Gl
            * `GD` - Gd
            * `GP` - Gp
            * `GU` - Gu
            * `GT` - Gt
            * `GG` - Gg
            * `GN` - Gn
            * `GW` - Gw
            * `GY` - Gy
            * `HT` - Ht
            * `HM` - Hm
            * `VA` - Va
            * `HN` - Hn
            * `HK` - Hk
            * `HU` - Hu
            * `IS` - Is
            * `IN` - In
            * `ID` - Id
            * `IR` - Ir
            * `IQ` - Iq
            * `IE` - Ie
            * `IM` - Im
            * `IL` - Il
            * `IT` - It
            * `JM` - Jm
            * `JP` - Jp
            * `JE` - Je
            * `JO` - Jo
            * `KZ` - Kz
            * `KE` - Ke
            * `KI` - Ki
            * `KP` - Kp
            * `KR` - Kr
            * `KW` - Kw
            * `KG` - Kg
            * `LA` - La
            * `LV` - Lv
            * `LB` - Lb
            * `LS` - Ls
            * `LR` - Lr
            * `LY` - Ly
            * `LI` - Li
            * `LT` - Lt
            * `LU` - Lu
            * `MO` - Mo
            * `MK` - Mk
            * `MG` - Mg
            * `MW` - Mw
            * `MY` - My
            * `MV` - Mv
            * `ML` - Ml
            * `MT` - Mt
            * `MH` - Mh
            * `MQ` - Mq
            * `MR` - Mr
            * `MU` - Mu
            * `YT` - Yt
            * `MX` - Mx
            * `FM` - Fm
            * `MD` - Md
            * `MC` - Mc
            * `MN` - Mn
            * `ME` - Me
            * `MS` - Ms
            * `MA` - Ma
            * `MZ` - Mz
            * `MM` - Mm
            * `NA` - Na
            * `NR` - Nr
            * `NP` - Np
            * `NL` - Nl
            * `NC` - Nc
            * `NZ` - Nz
            * `NI` - Ni
            * `NE` - Ne
            * `NG` - Ng
            * `NU` - Nu
            * `NF` - Nf
            * `MP` - Mp
            * `NO` - No
            * `OM` - Om
            * `PK` - Pk
            * `PW` - Pw
            * `PS` - Ps
            * `PA` - Pa
            * `PG` - Pg
            * `PY` - Py
            * `PE` - Pe
            * `PH` - Ph
            * `PN` - Pn
            * `PL` - Pl
            * `PT` - Pt
            * `PR` - Pr
            * `QA` - Qa
            * `RO` - Ro
            * `RU` - Ru
            * `RW` - Rw
            * `RE` - Re
            * `BL` - Bl
            * `SH` - Sh
            * `KN` - Kn
            * `LC` - Lc
            * `MF` - Mf
            * `PM` - Pm
            * `VC` - Vc
            * `WS` - Ws
            * `SM` - Sm
            * `ST` - St
            * `SA` - Sa
            * `SN` - Sn
            * `RS` - Rs
            * `SC` - Sc
            * `SL` - Sl
            * `SG` - Sg
            * `SX` - Sx
            * `SK` - Sk
            * `SI` - Si
            * `SB` - Sb
            * `SO` - So
            * `ZA` - Za
            * `GS` - Gs
            * `SS` - Ss
            * `ES` - Es
            * `LK` - Lk
            * `SD` - Sd
            * `SR` - Sr
            * `SJ` - Sj
            * `SZ` - Sz
            * `SE` - Se
            * `CH` - Ch
            * `SY` - Sy
            * `TW` - Tw
            * `TJ` - Tj
            * `TZ` - Tz
            * `TH` - Th
            * `TL` - Tl
            * `TG` - Tg
            * `TK` - Tk
            * `TO` - To
            * `TT` - Tt
            * `TN` - Tn
            * `TR` - Tr
            * `TM` - Tm
            * `TC` - Tc
            * `TV` - Tv
            * `UG` - Ug
            * `UA` - Ua
            * `AE` - Ae
            * `GB` - Gb
            * `US` - Us
            * `UM` - Um
            * `UY` - Uy
            * `UZ` - Uz
            * `VU` - Vu
            * `VE` - Ve
            * `VN` - Vn
            * `VG` - Vg
            * `VI` - Vi
            * `WF` - Wf
            * `EH` - Eh
            * `YE` - Ye
            * `ZM` - Zm
            * `ZW` - Zw
            * `AX` - Ax
          oneOf:
            - $ref: '#/components/schemas/CountryEnum'
            - $ref: '#/components/schemas/BlankEnum'
            - $ref: '#/components/schemas/NullEnum'
        initialSites:
          type: array
          items:
            type: string
            format: uuid
            title: InitialSites
          description: >-
            Initial sites associated with this connection. Initial sites are
            often useful to manually associate sites with the connection before
            the connection is validated or onboarded.
        initialDatasourceTypes:
          type: array
          items:
            $ref: '#/components/schemas/DataSourceTypeEnum'
          description: >-
            Initial datasource types associated with this workflow. Initial
            datasource types are used to filter the workflows when the number of
            datasource types associated via accounts is 0.
          maxItems: 10
        username:
          type:
            - string
            - 'null'
          description: Username for the integration workflow.
        workflowOwnerEmail:
          type:
            - string
            - 'null'
          format: email
          description: >-
            Utility login / data owner email address. This person will receive
            notifications if data is missing or if the utility data connection
            is misconfigured.
        dataCollectionStartDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            Date when data collection for the workflow begins. This is the date
            from which Nectar will pull historical data. This field overrides
            the site and company level dataCollectionStartDate fields.
        multiplyByOccupancy:
          type: boolean
          description: Flag to indicate if data should be multiplied by occupancy.
        isActive:
          type: boolean
          description: >-
            Whether this connection is actively collecting data. When set to
            False, the connection stops collecting new data but all historical
            data is preserved, and the status field will reflect as DEACTIVATED.
            Set to True to reactivate data collection. This is the preferred way
            to deactivate a connection instead of deleting it.
        publicCompanyId:
          type: string
          description: >-
            Deprecated — use the invitation system instead. Public ID of the
            company used in magic link URLs.
        connectionMagicLinkSecret:
          type: string
          description: >-
            Deprecated — use the invitation system instead. Fernet-encrypted
            secret for connection-level magic links.
        statusLastUpdateTime:
          type:
            - string
            - 'null'
          format: date-time
          description: When we recorded this status
        statusFirstSeenTime:
          type:
            - string
            - 'null'
          format: date-time
          description: When did we initially set this status
        statusErrorDetail:
          type:
            - string
            - 'null'
          description: Relevant details if it’s an error status
      required:
        - connectionMagicLinkSecret
        - created
        - id
        - publicCompanyId
        - statusErrorDetail
        - statusFirstSeenTime
        - statusLastUpdateTime
    ErrorResponse:
      type: object
      description: Serializer for error responses.
      properties:
        detail:
          type: string
        error:
          type: string
    CountryEnum:
      enum:
        - AF
        - AL
        - DZ
        - AS
        - AD
        - AO
        - AI
        - AQ
        - AG
        - AR
        - AM
        - AW
        - AU
        - AT
        - AZ
        - BS
        - BH
        - BD
        - BB
        - BY
        - BE
        - BZ
        - BJ
        - BM
        - BT
        - BO
        - BQ
        - BA
        - BW
        - BV
        - BR
        - IO
        - BN
        - BG
        - BF
        - BI
        - KH
        - CM
        - CA
        - CV
        - KY
        - CF
        - TD
        - CL
        - CN
        - CX
        - CC
        - CO
        - KM
        - CG
        - CD
        - CK
        - CR
        - HR
        - CU
        - CW
        - CY
        - CZ
        - CI
        - DK
        - DJ
        - DM
        - DO
        - EC
        - EG
        - SV
        - GQ
        - ER
        - EE
        - ET
        - FK
        - FO
        - FJ
        - FI
        - FR
        - GF
        - PF
        - TF
        - GA
        - GM
        - GE
        - DE
        - GH
        - GI
        - GR
        - GL
        - GD
        - GP
        - GU
        - GT
        - GG
        - GN
        - GW
        - GY
        - HT
        - HM
        - VA
        - HN
        - HK
        - HU
        - IS
        - IN
        - ID
        - IR
        - IQ
        - IE
        - IM
        - IL
        - IT
        - JM
        - JP
        - JE
        - JO
        - KZ
        - KE
        - KI
        - KP
        - KR
        - KW
        - KG
        - LA
        - LV
        - LB
        - LS
        - LR
        - LY
        - LI
        - LT
        - LU
        - MO
        - MK
        - MG
        - MW
        - MY
        - MV
        - ML
        - MT
        - MH
        - MQ
        - MR
        - MU
        - YT
        - MX
        - FM
        - MD
        - MC
        - MN
        - ME
        - MS
        - MA
        - MZ
        - MM
        - NA
        - NR
        - NP
        - NL
        - NC
        - NZ
        - NI
        - NE
        - NG
        - NU
        - NF
        - MP
        - 'NO'
        - OM
        - PK
        - PW
        - PS
        - PA
        - PG
        - PY
        - PE
        - PH
        - PN
        - PL
        - PT
        - PR
        - QA
        - RO
        - RU
        - RW
        - RE
        - BL
        - SH
        - KN
        - LC
        - MF
        - PM
        - VC
        - WS
        - SM
        - ST
        - SA
        - SN
        - RS
        - SC
        - SL
        - SG
        - SX
        - SK
        - SI
        - SB
        - SO
        - ZA
        - GS
        - SS
        - ES
        - LK
        - SD
        - SR
        - SJ
        - SZ
        - SE
        - CH
        - SY
        - TW
        - TJ
        - TZ
        - TH
        - TL
        - TG
        - TK
        - TO
        - TT
        - TN
        - TR
        - TM
        - TC
        - TV
        - UG
        - UA
        - AE
        - GB
        - US
        - UM
        - UY
        - UZ
        - VU
        - VE
        - VN
        - VG
        - VI
        - WF
        - EH
        - YE
        - ZM
        - ZW
        - AX
      type: string
      description: |-
        * `AF` - Af
        * `AL` - Al
        * `DZ` - Dz
        * `AS` - As
        * `AD` - Ad
        * `AO` - Ao
        * `AI` - Ai
        * `AQ` - Aq
        * `AG` - Ag
        * `AR` - Ar
        * `AM` - Am
        * `AW` - Aw
        * `AU` - Au
        * `AT` - At
        * `AZ` - Az
        * `BS` - Bs
        * `BH` - Bh
        * `BD` - Bd
        * `BB` - Bb
        * `BY` - By
        * `BE` - Be
        * `BZ` - Bz
        * `BJ` - Bj
        * `BM` - Bm
        * `BT` - Bt
        * `BO` - Bo
        * `BQ` - Bq
        * `BA` - Ba
        * `BW` - Bw
        * `BV` - Bv
        * `BR` - Br
        * `IO` - Io
        * `BN` - Bn
        * `BG` - Bg
        * `BF` - Bf
        * `BI` - Bi
        * `KH` - Kh
        * `CM` - Cm
        * `CA` - Ca
        * `CV` - Cv
        * `KY` - Ky
        * `CF` - Cf
        * `TD` - Td
        * `CL` - Cl
        * `CN` - Cn
        * `CX` - Cx
        * `CC` - Cc
        * `CO` - Co
        * `KM` - Km
        * `CG` - Cg
        * `CD` - Cd
        * `CK` - Ck
        * `CR` - Cr
        * `HR` - Hr
        * `CU` - Cu
        * `CW` - Cw
        * `CY` - Cy
        * `CZ` - Cz
        * `CI` - Ci
        * `DK` - Dk
        * `DJ` - Dj
        * `DM` - Dm
        * `DO` - Do
        * `EC` - Ec
        * `EG` - Eg
        * `SV` - Sv
        * `GQ` - Gq
        * `ER` - Er
        * `EE` - Ee
        * `ET` - Et
        * `FK` - Fk
        * `FO` - Fo
        * `FJ` - Fj
        * `FI` - Fi
        * `FR` - Fr
        * `GF` - Gf
        * `PF` - Pf
        * `TF` - Tf
        * `GA` - Ga
        * `GM` - Gm
        * `GE` - Ge
        * `DE` - De
        * `GH` - Gh
        * `GI` - Gi
        * `GR` - Gr
        * `GL` - Gl
        * `GD` - Gd
        * `GP` - Gp
        * `GU` - Gu
        * `GT` - Gt
        * `GG` - Gg
        * `GN` - Gn
        * `GW` - Gw
        * `GY` - Gy
        * `HT` - Ht
        * `HM` - Hm
        * `VA` - Va
        * `HN` - Hn
        * `HK` - Hk
        * `HU` - Hu
        * `IS` - Is
        * `IN` - In
        * `ID` - Id
        * `IR` - Ir
        * `IQ` - Iq
        * `IE` - Ie
        * `IM` - Im
        * `IL` - Il
        * `IT` - It
        * `JM` - Jm
        * `JP` - Jp
        * `JE` - Je
        * `JO` - Jo
        * `KZ` - Kz
        * `KE` - Ke
        * `KI` - Ki
        * `KP` - Kp
        * `KR` - Kr
        * `KW` - Kw
        * `KG` - Kg
        * `LA` - La
        * `LV` - Lv
        * `LB` - Lb
        * `LS` - Ls
        * `LR` - Lr
        * `LY` - Ly
        * `LI` - Li
        * `LT` - Lt
        * `LU` - Lu
        * `MO` - Mo
        * `MK` - Mk
        * `MG` - Mg
        * `MW` - Mw
        * `MY` - My
        * `MV` - Mv
        * `ML` - Ml
        * `MT` - Mt
        * `MH` - Mh
        * `MQ` - Mq
        * `MR` - Mr
        * `MU` - Mu
        * `YT` - Yt
        * `MX` - Mx
        * `FM` - Fm
        * `MD` - Md
        * `MC` - Mc
        * `MN` - Mn
        * `ME` - Me
        * `MS` - Ms
        * `MA` - Ma
        * `MZ` - Mz
        * `MM` - Mm
        * `NA` - Na
        * `NR` - Nr
        * `NP` - Np
        * `NL` - Nl
        * `NC` - Nc
        * `NZ` - Nz
        * `NI` - Ni
        * `NE` - Ne
        * `NG` - Ng
        * `NU` - Nu
        * `NF` - Nf
        * `MP` - Mp
        * `NO` - No
        * `OM` - Om
        * `PK` - Pk
        * `PW` - Pw
        * `PS` - Ps
        * `PA` - Pa
        * `PG` - Pg
        * `PY` - Py
        * `PE` - Pe
        * `PH` - Ph
        * `PN` - Pn
        * `PL` - Pl
        * `PT` - Pt
        * `PR` - Pr
        * `QA` - Qa
        * `RO` - Ro
        * `RU` - Ru
        * `RW` - Rw
        * `RE` - Re
        * `BL` - Bl
        * `SH` - Sh
        * `KN` - Kn
        * `LC` - Lc
        * `MF` - Mf
        * `PM` - Pm
        * `VC` - Vc
        * `WS` - Ws
        * `SM` - Sm
        * `ST` - St
        * `SA` - Sa
        * `SN` - Sn
        * `RS` - Rs
        * `SC` - Sc
        * `SL` - Sl
        * `SG` - Sg
        * `SX` - Sx
        * `SK` - Sk
        * `SI` - Si
        * `SB` - Sb
        * `SO` - So
        * `ZA` - Za
        * `GS` - Gs
        * `SS` - Ss
        * `ES` - Es
        * `LK` - Lk
        * `SD` - Sd
        * `SR` - Sr
        * `SJ` - Sj
        * `SZ` - Sz
        * `SE` - Se
        * `CH` - Ch
        * `SY` - Sy
        * `TW` - Tw
        * `TJ` - Tj
        * `TZ` - Tz
        * `TH` - Th
        * `TL` - Tl
        * `TG` - Tg
        * `TK` - Tk
        * `TO` - To
        * `TT` - Tt
        * `TN` - Tn
        * `TR` - Tr
        * `TM` - Tm
        * `TC` - Tc
        * `TV` - Tv
        * `UG` - Ug
        * `UA` - Ua
        * `AE` - Ae
        * `GB` - Gb
        * `US` - Us
        * `UM` - Um
        * `UY` - Uy
        * `UZ` - Uz
        * `VU` - Vu
        * `VE` - Ve
        * `VN` - Vn
        * `VG` - Vg
        * `VI` - Vi
        * `WF` - Wf
        * `EH` - Eh
        * `YE` - Ye
        * `ZM` - Zm
        * `ZW` - Zw
        * `AX` - Ax
    DatasourceSkeletonSerializerV2:
      type: object
      description: Serializer for Datasource instances.
      properties:
        name:
          type: string
          description: Name of the utility company / utility provider.
          maxLength: 200
        url:
          type: string
          description: >-
            Brand-specific portal entry point URL. Optional for email-only
            providers.
          maxLength: 2083
      required:
        - name
        - url
    AccountWithDatasourceTypes:
      type: object
      description: >-
        Account serializer specifically for the connection view that includes
        datasourceTypes.


        For this to work, the datasourceTypes need to be pre-populated in the
        account object.
      properties:
        id:
          type: string
          format: uuid
          description: UUID of the account.
        accountNumber:
          type: string
          description: >-
            The actual account number. For utilities without account numbers,
            leave blank.
          maxLength: 200
        meters:
          type: array
          items:
            type: string
            format: uuid
            description: UUID of the meter site usage data entry.
        isTracked:
          type: boolean
          description: >-
            Deprecated boolean alias. UNSET is treated as True for backward
            compatibility.
        trackingStatus:
          allOf:
            - $ref: '#/components/schemas/TrackingStatusEnum'
          description: >-
            User-mutable tracking intent for this account. When set to DISABLED,
            data collection stops and the status field reflects as
            CUSTOMER_NOT_TRACKED. ENABLED resumes data collection. UNSET means
            no tracking decision has been made yet.


            * `ENABLED` - Enabled

            * `DISABLED` - Disabled

            * `UNSET` - Unset
        isDuplicated:
          type: string
        dataCollectionStartDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            Date when data collection for the account begins. This is the date
            from which Nectar will pull historical data. This field overrides
            the site, company, and connection level dataCollectionStartDate
            fields.
        isCollectingInvoiceData:
          type: boolean
          description: >-
            Indicates whether this account is collecting invoice data. If True,
            Nectar will collect invoice data with a maximum granularity of
            weekly intervals.
        isCollectingSmartMeterData:
          type: boolean
          description: >-
            Indicates whether this account is smart metered. If True, Nectar
            will collect metered data with a maximum granularity of daily
            intervals.
        datasourceTypes:
          type: array
          items:
            type: string
          description: >-
            List of unique datasource types for all meters associated with the
            account.
        lastServiceDate:
          type:
            - string
            - 'null'
          format: date
          description: >-
            The date when the account was closed by the utility (the end date of
            the last meter reading).
        status:
          allOf:
            - $ref: '#/components/schemas/AccountWithDatasourceTypesStatusEnum'
          description: >-
            Observable account status, read-only to API clients.
            CUSTOMER_NOT_TRACKED means the account was opted out via
            trackingStatus=DISABLED. COMPANY_INACTIVE means the parent company
            was deactivated. All other values reflect the most recent scrape
            outcome.


            * `ONBOARDED` - Onboarded

            * `PULL_COMPLETED` - Pull Completed

            * `OTHER_ERROR` - Other Error

            * `DUPLICATE` - Duplicate

            * `OLD_ACCOUNT` - Old Account

            * `ACCOUNT_NOT_FOUND` - Account Not Found

            * `PDF_DOWNLOAD_FAILED` - Pdf Download Failed

            * `NO_DOCUMENTS_FOUND` - No Documents Found

            * `WORKFLOW_NOT_ACCESSIBLE` - Workflow Not Accessible

            * `COMPANY_INACTIVE` - Company Inactive

            * `CUSTOMER_NOT_TRACKED` - Customer Not Tracked

            * `CONNECTION_DEACTIVATED` - Connection Deactivated

            * `DETECTED` - Detected
        statusLastUpdateTime:
          type:
            - string
            - 'null'
          format: date-time
          description: When we recorded this status
        statusFirstSeenTime:
          type:
            - string
            - 'null'
          format: date-time
          description: When did we initially set this status
        statusErrorDetail:
          type:
            - string
            - 'null'
          description: Relevant details if it’s an error status
      required:
        - id
        - isDuplicated
        - isTracked
        - meters
        - statusErrorDetail
        - statusFirstSeenTime
        - statusLastUpdateTime
    CompanySkeletonSerializerV2:
      type: object
      description: Skeleton serializer for externally available fields of a Company object.
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the company.
        externalId:
          type:
            - string
            - 'null'
          description: >-
            External identifier for the company. Used to associate company in
            Nectar with company within your database.
        name:
          type: string
          description: Name of the company.
          maxLength: 200
      required:
        - id
        - name
    ConnectionStatusEnum:
      enum:
        - PENDING
        - UNDER_INVESTIGATION
        - CONNECTED
        - MFA_TOKEN_EXPIRED
        - PASSWORD_INCORRECT
        - NEW_PASSWORD_NEEDED
        - ADDITIONAL_CREDENTIALS_NEEDED
        - WEBSITE_DOWN
        - NO_ACCOUNTS_FOUND
        - OTHER_ERROR
        - COMPANY_INACTIVE
        - DEACTIVATED
        - URL_INACCESSIBLE
      type: string
      description: |-
        * `PENDING` - Pending
        * `UNDER_INVESTIGATION` - Under Investigation
        * `CONNECTED` - Connected
        * `MFA_TOKEN_EXPIRED` - Mfa Token Expired
        * `PASSWORD_INCORRECT` - Password Incorrect
        * `NEW_PASSWORD_NEEDED` - New Password Needed
        * `ADDITIONAL_CREDENTIALS_NEEDED` - Additional Credentials Needed
        * `WEBSITE_DOWN` - Website Down
        * `NO_ACCOUNTS_FOUND` - No Accounts Found
        * `OTHER_ERROR` - Other Error
        * `COMPANY_INACTIVE` - Company Inactive
        * `DEACTIVATED` - Deactivated
        * `URL_INACCESSIBLE` - Url Inaccessible
    BlankEnum:
      enum:
        - ''
    NullEnum:
      type: 'null'
    DataSourceTypeEnum:
      enum:
        - ELECTRICITY
        - GAS
        - WATER
        - DISTRICT
        - WASTE
        - FUEL
        - MISC
        - REFRIGERANT
        - SOLAR
        - TELECOM
      type: string
      description: |-
        * `ELECTRICITY` - Electricity
        * `GAS` - Gas
        * `WATER` - Water
        * `DISTRICT` - District
        * `WASTE` - Waste
        * `FUEL` - Fuel
        * `MISC` - Misc
        * `REFRIGERANT` - Refrigerant
        * `SOLAR` - Solar
        * `TELECOM` - Telecom
    TrackingStatusEnum:
      enum:
        - ENABLED
        - DISABLED
        - UNSET
      type: string
      description: |-
        * `ENABLED` - Enabled
        * `DISABLED` - Disabled
        * `UNSET` - Unset
    AccountWithDatasourceTypesStatusEnum:
      enum:
        - ONBOARDED
        - PULL_COMPLETED
        - OTHER_ERROR
        - DUPLICATE
        - OLD_ACCOUNT
        - ACCOUNT_NOT_FOUND
        - PDF_DOWNLOAD_FAILED
        - NO_DOCUMENTS_FOUND
        - WORKFLOW_NOT_ACCESSIBLE
        - COMPANY_INACTIVE
        - CUSTOMER_NOT_TRACKED
        - CONNECTION_DEACTIVATED
        - DETECTED
      type: string
      description: |-
        * `ONBOARDED` - Onboarded
        * `PULL_COMPLETED` - Pull Completed
        * `OTHER_ERROR` - Other Error
        * `DUPLICATE` - Duplicate
        * `OLD_ACCOUNT` - Old Account
        * `ACCOUNT_NOT_FOUND` - Account Not Found
        * `PDF_DOWNLOAD_FAILED` - Pdf Download Failed
        * `NO_DOCUMENTS_FOUND` - No Documents Found
        * `WORKFLOW_NOT_ACCESSIBLE` - Workflow Not Accessible
        * `COMPANY_INACTIVE` - Company Inactive
        * `CUSTOMER_NOT_TRACKED` - Customer Not Tracked
        * `CONNECTION_DEACTIVATED` - Connection Deactivated
        * `DETECTED` - Detected
  securitySchemes:
    ExternalAuthentication:
      type: apiKey
      in: header
      name: X-API-KEY

````